/* ----------------------------------------------------
   The forward and backwards area-preserving Henon map
   ---------------------------------------------------- */
void
mapfw (double *x0, double *x1, void *pars){
    // cast pars to a double pointer
    double *a = (double*) pars;
    x1[1] = x0[1] +  (*a)*sin (x0[0]);
    x1[0] = x0[0] + x1[1];
    // notice the lack of compactification
}

void
mapbw (double *x0, double *x1, void *pars){
    // cast pars to a double pointer
    double *a = (double*) pars;
    x1[0] = x0[0] - x0[1];
    x1[1] = x0[1] - (*a)*sin (x1[0]);
    // notice the lack of compactification
}

/* ----------------------------------------------------
   The Jacobian of the map
   ---------------------------------------------------- */
void
jacobian (double **J, double *x, void *pars){
    double *a = (double*) pars;
    J[0][0] = 1.0+(*a)*cos(x[0]);
    J[0][1] = 1.0;
    J[1][0] = (*a)*cos(x[0]);
    J[1][1] = 1.0;
}

/* ----------------------------------------------------
   Define the relevant difference between two vectors
   ---------------------------------------------------- */
void
vec_dif (double *x01, double *x1, double *x0){
    x01[0] = x1[0] - x0[0];
    x01[1] = x1[1] - x0[1];
}
